/*
 * Copyright (C) 2000 Ben Reser <ben@reser.org>
 * 
 *     This program is free software; you can redistribute it
 *     and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation; either
 *     version 2 of the License, or (at your option) any later
 *     version.
 * 
 *     This program is distributed in the hope that it will be
 *     useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more
 *     details.
 * 
 *     You should have received a copy of the GNU General Public
 *     License along with this program; if not, write to the Free
 *     Software Foundation, Inc., 675 Mass Ave, Cambridge, MA
 *     02139, USA.
 * 
 */


#include <stdio.h>

#include "escape.h"


/* 
 * Replaces commas with %2C so that URLS with commas in them will work with
 * netscape.  This was stolen out of the quote function in urlview which was
 * stolen from someplace else.
 */

char *escape (char *d, size_t l, const char *f)
{
  size_t i, j = 0;

  if(!f) 
  {
    *d = '\0';
    return 0;
  }

  /* leave some space for the trailing characters. */
  l -= 6;
  
  for(i = 0; j < l && f[i]; i++)
  {
    if(f[i] == ',')
    {
      d[j++] = '%';
      d[j++] = '2';
      d[j++] = 'C';
    }
    else
      d[j++] = f[i];
  }
  
  d[j]   = '\0';
  
  return d;
}
